Index: tools/autotool.py
===================================================================
--- tools/autotool.py	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ tools/autotool.py	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -54,4 +54,5 @@
 PACKAGE_GCC = "preferably version 4.7.0 or newer"
 PACKAGE_CROSS = "use tools/toolchain.sh to build the cross-compiler toolchain"
+PACKAGE_CLANG = "reasonably recent version of clang needs to be installed"
 
 COMPILER_FAIL = "The compiler is probably not capable to compile HelenOS."
@@ -208,22 +209,20 @@
 
 def get_target(config):
+	platform = None
+	gnu_target = None
+	helenos_target = None
 	target = None
-	gnu_target = None
-	clang_target = None
-	helenos_target = None
 	cc_args = []
 	
 	if (config['PLATFORM'] == "abs32le"):
 		check_config(config, "CROSS_TARGET")
-		target = config['CROSS_TARGET']
+		platform = config['CROSS_TARGET']
 		
 		if (config['CROSS_TARGET'] == "arm32"):
 			gnu_target = "arm-linux-gnueabi"
-			clang_target = "arm-unknown-none"
 			helenos_target = "arm-helenos-gnueabi"
 		
 		if (config['CROSS_TARGET'] == "ia32"):
 			gnu_target = "i686-pc-linux-gnu"
-			clang_target = "i686-unknown-none"
 			helenos_target = "i686-pc-helenos"
 		
@@ -231,27 +230,23 @@
 			cc_args.append("-mabi=32")
 			gnu_target = "mipsel-linux-gnu"
-			clang_target = "mipsel-unknown-none"
 			helenos_target = "mipsel-helenos"
 	
 	if (config['PLATFORM'] == "amd64"):
-		target = config['PLATFORM']
-		gnu_target = "amd64-linux-gnu"
-		clang_target = "x86_64-unknown-none"
+		platform = config['PLATFORM']
+		gnu_target = "amd64-unknown-elf"
 		helenos_target = "amd64-helenos"
 	
 	if (config['PLATFORM'] == "arm32"):
-		target = config['PLATFORM']
+		platform = config['PLATFORM']
 		gnu_target = "arm-linux-gnueabi"
-		clang_target = "arm-unknown-none-eabi"
 		helenos_target = "arm-helenos-gnueabi"
 	
 	if (config['PLATFORM'] == "ia32"):
-		target = config['PLATFORM']
+		platform = config['PLATFORM']
 		gnu_target = "i686-pc-linux-gnu"
-		clang_target = "i686-unknown-none"
 		helenos_target = "i686-pc-helenos"
 	
 	if (config['PLATFORM'] == "ia64"):
-		target = config['PLATFORM']
+		platform = config['PLATFORM']
 		gnu_target = "ia64-pc-linux-gnu"
 		helenos_target = "ia64-pc-helenos"
@@ -262,13 +257,11 @@
 		
 		if ((config['MACHINE'] == "msim") or (config['MACHINE'] == "lmalta")):
-			target = config['PLATFORM']
+			platform = config['PLATFORM']
 			gnu_target = "mipsel-linux-gnu"
-			clang_target = "mipsel-unknown-none"
 			helenos_target = "mipsel-helenos"
 		
 		if ((config['MACHINE'] == "bmalta")):
-			target = "mips32eb"
+			platform = "mips32eb"
 			gnu_target = "mips-linux-gnu"
-			clang_target = "mips-unknown-none"
 			helenos_target = "mips-helenos"
 	
@@ -278,28 +271,29 @@
 		
 		if (config['MACHINE'] == "msim"):
-			target = config['PLATFORM']
+			platform = config['PLATFORM']
 			gnu_target = "mips64el-linux-gnu"
-			clang_target = "mips64el-unknown-none"
 			helenos_target = "mips64el-helenos"
 	
 	if (config['PLATFORM'] == "ppc32"):
-		target = config['PLATFORM']
+		platform = config['PLATFORM']
 		gnu_target = "ppc-linux-gnu"
-		clang_target = "ppc-unknown-none"
 		helenos_target = "ppc-helenos"
 	
 	if (config['PLATFORM'] == "riscv64"):
-		target = config['PLATFORM']
+		platform = config['PLATFORM']
 		gnu_target = "riscv64-unknown-linux-gnu"
-		clang_target = "riscv-unknown-none"
 		helenos_target = "riscv64-helenos"
 	
 	if (config['PLATFORM'] == "sparc64"):
-		target = config['PLATFORM']
+		platform = config['PLATFORM']
 		gnu_target = "sparc64-linux-gnu"
-		clang_target = "sparc-unknown-none"
 		helenos_target = "sparc64-helenos"
 	
-	return (target, cc_args, gnu_target, clang_target, helenos_target)
+	if (config['COMPILER'] == "gcc_helenos"):
+		target = helenos_target
+	else:
+		target = gnu_target
+	
+	return (platform, cc_args, target)
 
 def check_app(args, name, details):
@@ -351,4 +345,14 @@
 	return found
 
+def check_clang(path, prefix, common, details):
+	"Check for clang"
+	
+	common['CLANG'] = "%sclang" % prefix
+	
+	if (not path is None):
+		common['CLANG'] = "%s/%s" % (path, common['CLANG'])
+	
+	check_app([common['CLANG'], "--version"], "clang", details)
+
 def check_gcc(path, prefix, common, details):
 	"Check for GCC"
@@ -427,6 +431,5 @@
 	outf.close()
 	
-	args = [common['CC']]
-	args.extend(common['CC_ARGS'])
+	args = common['CC_AUTOGEN'].split(' ')
 	args.extend(["-S", "-o", PROBE_OUTPUT, PROBE_SOURCE])
 	
@@ -547,6 +550,5 @@
 	outf.close()
 	
-	args = [common['CC']]
-	args.extend(common['CC_ARGS'])
+	args = common['CC_AUTOGEN'].split(' ')
 	args.extend(["-S", "-o", PROBE_INT128_OUTPUT, PROBE_INT128_SOURCE])
 	
@@ -849,40 +851,37 @@
 		check_app(["make", "--version"], "Make utility", "preferably GNU Make")
 		check_app(["makedepend", "-f", "-"], "Makedepend utility", "usually part of imake or xutils")
+		check_app(["unzip"], "unzip utility", "usually part of zip/unzip utilities")
+		
+		platform, cc_args, target = get_target(config)
+		
+		if (platform is None) or (target is None):
+			print_error(["Unsupported compiler target.",
+				     "Please contact the developers of HelenOS."])
+		
+		path = "%s/%s/bin" % (cross_prefix, target)
+		
+		# Compatibility with earlier toolchain paths.
+		if not os.path.exists(path):
+			if (config['COMPILER'] == "gcc_helenos"):
+				check_path = "%s/%s/%s" % (cross_helenos_prefix, platform, target)
+				if not os.path.exists(check_path):
+					print_error(["Toolchain for target is not installed, or CROSS_PREFIX is not set correctly."])
+				path = "%s/%s/bin" % (cross_helenos_prefix, platform)
+			else:
+				check_path = "%s/%s/%s" % (cross_prefix, platform, target)
+				if not os.path.exists(check_path):
+					print_error(["Toolchain for target is not installed, or CROSS_PREFIX is not set correctly."])
+				path = "%s/%s/bin" % (cross_prefix, platform)
+		
+		prefix = "%s-" % target
 		
 		# Compiler
-		common['CC_ARGS'] = []
-		if (config['COMPILER'] == "gcc_cross"):
-			target, cc_args, gnu_target, clang_target, helenos_target = get_target(config)
-			
-			if (target is None) or (gnu_target is None):
-				print_error(["Unsupported compiler target for GNU GCC.",
-				             "Please contact the developers of HelenOS."])
-			
-			path = "%s/%s/bin" % (cross_prefix, target)
-			prefix = "%s-" % gnu_target
-			
+		if (config['COMPILER'] == "gcc_cross" or config['COMPILER'] == "gcc_helenos"):
 			check_gcc(path, prefix, common, PACKAGE_CROSS)
 			check_binutils(path, prefix, common, PACKAGE_CROSS)
 			
 			check_common(common, "GCC")
-			common['CC'] = common['GCC']
-			common['CC_ARGS'].extend(cc_args)
-		
-		if (config['COMPILER'] == "gcc_helenos"):
-			target, cc_args, gnu_target, clang_target, helenos_target = get_target(config)
-			
-			if (target is None) or (helenos_target is None):
-				print_error(["Unsupported compiler target for GNU GCC.",
-				             "Please contact the developers of HelenOS."])
-			
-			path = "%s/%s/bin" % (cross_helenos_prefix, target)
-			prefix = "%s-" % helenos_target
-			
-			check_gcc(path, prefix, common, PACKAGE_CROSS)
-			check_binutils(path, prefix, common, PACKAGE_CROSS)
-			
-			check_common(common, "GCC")
-			common['CC'] = common['GCC']
-			common['CC_ARGS'].extend(cc_args)
+			common['CC'] = " ".join([common['GCC']] + cc_args)
+			common['CC_AUTOGEN'] = common['CC']
 		
 		if (config['COMPILER'] == "gcc_native"):
@@ -892,32 +891,19 @@
 			check_common(common, "GCC")
 			common['CC'] = common['GCC']
-		
-		if (config['COMPILER'] == "icc"):
-			check_app([common['CC'], "-V"], "Intel C++ Compiler", "support is experimental")
-			check_gcc(None, "", common, PACKAGE_GCC)
-			check_binutils(None, binutils_prefix, common, PACKAGE_BINUTILS)
+			common['CC_AUTOGEN'] = common['CC']
+		
+		if (config['COMPILER'] == "clang"):
+			check_binutils(path, prefix, common, PACKAGE_CROSS)
+			check_clang(path, prefix, common, PACKAGE_CLANG)
 			
-			common['CC'] = "icc"
-		
-		if (config['COMPILER'] == "clang"):
-			target, cc_args, gnu_target, clang_target, helenos_target = get_target(config)
+			check_common(common, "CLANG")
+			common['CC'] = " ".join([common['CLANG']] + cc_args)
+			common['CC_AUTOGEN'] = common['CC'] + " -no-integrated-as"
 			
-			if (target is None) or (gnu_target is None) or (clang_target is None):
-				print_error(["Unsupported compiler target for clang.",
-				             "Please contact the developers of HelenOS."])
+			if (config['INTEGRATED_AS'] == "yes"):
+				common['CC'] += " -integrated-as"
 			
-			path = "%s/%s/bin" % (cross_prefix, target)
-			prefix = "%s-" % gnu_target
-			
-			check_app(["clang", "--version"], "clang compiler", "preferably version 1.0 or newer")
-			check_gcc(path, prefix, common, PACKAGE_GCC)
-			check_binutils(path, prefix, common, PACKAGE_BINUTILS)
-			
-			check_common(common, "GCC")
-			common['CC'] = "clang"
-			common['CC_ARGS'].extend(cc_args)
-			common['CC_ARGS'].append("-target")
-			common['CC_ARGS'].append(clang_target)
-			common['CLANG_TARGET'] = clang_target
+			if (config['INTEGRATED_AS'] == "no"):
+				common['CC'] += " -no-integrated-as"
 		
 		check_python()
Index: tools/ew.py
===================================================================
--- tools/ew.py	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ tools/ew.py	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -219,5 +219,5 @@
 
 def spike_run(platform, machine, processor):
-	run_in_console('spike image.boot', 'HelenOS/risvc64 on Spike')
+	run_in_console('spike -m1073741824:1073741824 image.boot', 'HelenOS/risvc64 on Spike')
 
 emulators = {
Index: tools/mkarray.py
===================================================================
--- tools/mkarray.py	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ tools/mkarray.py	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,29 +28,58 @@
 #
 """
-C structure creator
+Binary inline data packer
 """
 
 import sys
 import os
-import struct
+import zlib
+import zipfile
+import binascii
 
 def usage(prname):
 	"Print usage syntax"
-	print("%s <DESTINATION> <LABEL> <AS_PROLOG> [SOURCE ...]" % prname)
+	print("%s [--deflate] <DESTINATION> <LABEL> <AS_PROLOG> <SECTION> [SOURCE ...]" % prname)
+
+def arg_check():
+	if (len(sys.argv) < 5):
+		usage(sys.argv[0])
+		sys.exit()
+
+def deflate(data):
+	"Compress using deflate algorithm (without any headers)"
+	return zlib.compress(data, 9)[2:-4]
+
+def chunks(string, length):
+	"Produce string chunks"
+	for start in range(0, len(string), length):
+		yield string[start:start + length]
 
 def main():
-	if (len(sys.argv) < 4):
-		usage(sys.argv[0])
-		return
+	arg_check()
+	
+	if sys.argv[1] == "--deflate":
+		sys.argv.pop(1)
+		arg_check()
+		compress = True
+	else:
+		compress = False
 	
 	dest = sys.argv[1]
 	label = sys.argv[2]
 	as_prolog = sys.argv[3]
+	section = sys.argv[4]
 	
 	header_ctx = []
+	desc_ctx = []
+	size_ctx = []
 	data_ctx = []
 	
-	for src in sys.argv[4:]:
+	src_cnt = 0
+	
+	archive = zipfile.ZipFile("%s.zip" % dest, "w", zipfile.ZIP_STORED)
+	
+	for src in sys.argv[5:]:
 		basename = os.path.basename(src)
+		plainname = os.path.splitext(basename)[0]
 		symbol = basename.replace(".", "_")
 		
@@ -61,68 +90,97 @@
 		src_in.close()
 		
-		data_rec = "\t.byte "
+		length = len(src_data)
 		
-		fmt = 'B'
-		item_size = struct.calcsize(fmt)
-		offset = 0
-		cnt = 0
+		if compress:
+			src_data = deflate(src_data)
+			src_fname = os.path.basename("%s.deflate" % src)
+			archive.writestr(src_fname, src_data)
+		else:
+			src_fname = src
 		
-		while (len(src_data[offset:]) >= item_size):
-			byte = struct.unpack_from(fmt, src_data, offset)
-			
-			if (offset > 0):
-				if ((cnt % 15) == 0):
-					data_rec += "\n\t.byte "
-				else:
-					data_rec += ", "
-			
-			data_rec += "0x%x" % byte
-			offset += item_size
-			cnt += 1
+		if sys.version_info < (3,):
+			src_data = bytearray(src_data)
 		
-		data_rec += "\n"
+		length_out = len(src_data)
 		
-		header_ctx.append("extern uint64_t %s_size;" % symbol)
 		header_ctx.append("extern uint8_t %s[];" % symbol)
-		
-		data_ctx.append(".globl %s_size" % symbol)
-		data_ctx.append(".balign 8");
-		data_ctx.append(".size %s_size, 8" % symbol)
-		data_ctx.append("%s_size:" % symbol)
-		data_ctx.append("\t.quad %u\n" % offset)
+		header_ctx.append("extern size_t %s_size;" % symbol)
 		
 		data_ctx.append(".globl %s" % symbol)
 		data_ctx.append(".balign 8")
-		data_ctx.append(".size %s, %u" % (symbol, offset))
+		data_ctx.append(".size %s, %u" % (symbol, length_out))
 		data_ctx.append("%s:" % symbol)
-		data_ctx.append(data_rec)
+		data_ctx.append("\t.incbin \"%s\"\n" % src_fname)
+		
+		desc_field = []
+		desc_field.append("\t{")
+		desc_field.append("\t\t.name = \"%s\"," % plainname)
+		desc_field.append("\t\t.addr = (void *) %s," % symbol)
+		desc_field.append("\t\t.size = %u," % length_out)
+		desc_field.append("\t\t.inflated = %u," % length)
+		
+		if compress:
+			desc_field.append("\t\t.compressed = true")
+		else:
+			desc_field.append("\t\t.compressed = false")
+		
+		desc_field.append("\t}")
+		
+		desc_ctx.append("\n".join(desc_field))
+		
+		size_ctx.append("size_t %s_size = %u;" % (symbol, length_out))
+		
+		src_cnt += 1
 	
-	header = open("%s.h" % dest, "w")
+	data = ''
+	data += '/***************************************\n'
+	data += ' * AUTO-GENERATED FILE, DO NOT EDIT!!! *\n'
+	data += ' * Generated by: tools/mkarray.py      *\n'
+	data += ' ***************************************/\n\n'
+	data += "#ifndef %sS_H_\n" % label.upper()
+	data += "#define %sS_H_\n\n" % label.upper()
+	data += "#include <stddef.h>\n"
+	data += "#include <stdint.h>\n"
+	data += "#include <stdbool.h>\n\n"
+	data += "#define %sS  %u\n\n" % (label.upper(), src_cnt)
+	data += "typedef struct {\n"
+	data += "\tconst char *name;\n"
+	data += "\tvoid *addr;\n"
+	data += "\tsize_t size;\n"
+	data += "\tsize_t inflated;\n"
+	data += "\tbool compressed;\n"
+	data += "} %s_t;\n\n" % label
+	data += "extern %s_t %ss[];\n\n" % (label, label)
+	data += "\n".join(header_ctx)
+	data += "\n\n"
+	data += "#endif\n"
+	archive.writestr("%s.h" % dest, data)
 	
-	header.write('/***************************************\n')
-	header.write(' * AUTO-GENERATED FILE, DO NOT EDIT!!! *\n')
-	header.write(' * Generated by: tools/mkarray.py      *\n')
-	header.write(' ***************************************/\n\n')
-	header.write("#ifndef %s_H_\n" % label)
-	header.write("#define %s_H_\n\n" % label)
-	header.write("#include <stddef.h>\n")
-	header.write("#include <stdint.h>\n\n")
-	header.write("\n".join(header_ctx))
-	header.write("\n\n")
-	header.write("#endif\n")
+	data = ''
+	data += '/***************************************\n'
+	data += ' * AUTO-GENERATED FILE, DO NOT EDIT!!! *\n'
+	data += ' * Generated by: tools/mkarray.py      *\n'
+	data += ' ***************************************/\n\n'
+	data += as_prolog
+	data += "%s\n\n" % section
+	data += "\n".join(data_ctx)
+	data += "\n"
+	archive.writestr("%s.s" % dest, data)
 	
-	header.close()
+	data = ''
+	data += '/***************************************\n'
+	data += ' * AUTO-GENERATED FILE, DO NOT EDIT!!! *\n'
+	data += ' * Generated by: tools/mkarray.py      *\n'
+	data += ' ***************************************/\n\n'
+	data += "#include \"%s.h\"\n\n" % dest
+	data += "%s_t %ss[] = {\n" % (label, label)
+	data += ",\n".join(desc_ctx)
+	data += "\n"
+	data += "};\n\n"
+	data += "\n".join(size_ctx)
+	data += "\n"
+	archive.writestr("%s_desc.c" % dest, data)
 	
-	data = open("%s.s" % dest, "w")
-	
-	data.write('/***************************************\n')
-	data.write(' * AUTO-GENERATED FILE, DO NOT EDIT!!! *\n')
-	data.write(' * Generated by: tools/mkarray.py      *\n')
-	data.write(' ***************************************/\n\n')
-	data.write(as_prolog)
-	data.write('.data\n\n')
-	data.write("\n".join(data_ctx))
-	
-	data.close()
+	archive.close()
 
 if __name__ == '__main__':
Index: tools/toolchain.sh
===================================================================
--- tools/toolchain.sh	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ tools/toolchain.sh	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -73,5 +73,4 @@
 REAL_INSTALL=true
 USE_HELENOS_TARGET=false
-INSTALL_DIR="${BASEDIR}/PKG"
 
 #
@@ -283,4 +282,6 @@
 	ORIGINAL="`pwd`"
 	
+	mkdir -p "${OUTSIDE}"
+	
 	cd "${OUTSIDE}"
 	check_error $? "Unable to change directory to ${OUTSIDE}."
@@ -358,5 +359,5 @@
 	case "$1" in
 		"amd64")
-			LINUX_TARGET="amd64-linux-gnu"
+			LINUX_TARGET="amd64-unknown-elf"
 			HELENOS_TARGET="amd64-helenos"
 			;;
@@ -418,5 +419,6 @@
 	fi
 	
-	WORKDIR="${BASEDIR}/${PLATFORM}"
+	WORKDIR="${BASEDIR}/${TARGET}"
+	INSTALL_DIR="${WORKDIR}/PKG"
 	BINUTILSDIR="${WORKDIR}/binutils-${BINUTILS_VERSION}"
 	GCCDIR="${WORKDIR}/gcc-${GCC_VERSION}"
@@ -427,13 +429,6 @@
 		CROSS_PREFIX="/usr/local/cross"
 	fi
-	if [ -z "${CROSS_HELENOS_PREFIX}" ] ; then
-		CROSS_HELENOS_PREFIX="/usr/local/cross-helenos"
-	fi
-	
-	if $USE_HELENOS_TARGET ; then
-		PREFIX="${CROSS_HELENOS_PREFIX}/${PLATFORM}"
-	else
-		PREFIX="${CROSS_PREFIX}/${PLATFORM}"
-	fi
+	
+	PREFIX="${CROSS_PREFIX}/${TARGET}"
 	
 	echo ">>> Downloading tarballs"
@@ -443,8 +438,6 @@
 	
 	echo ">>> Removing previous content"
-	$REAL_INSTALL && cleanup_dir "${PREFIX}"
 	cleanup_dir "${WORKDIR}"
 	
-	$REAL_INSTALL && create_dir "${PREFIX}" "destination directory"
 	create_dir "${OBJDIR}" "GCC object directory"
 	
@@ -478,5 +471,5 @@
 		"--target=${TARGET}" \
 		"--prefix=${PREFIX}" "--program-prefix=${TARGET}-" \
-		--disable-nls --disable-werror
+		--disable-nls --disable-werror --enable-gold
 	check_error $? "Error configuring binutils."
 	
@@ -486,9 +479,5 @@
 	
 	change_title "binutils: install (${PLATFORM})"
-	if $REAL_INSTALL ; then
-		make install
-	else
-		make install "DESTDIR=${INSTALL_DIR}"
-	fi
+	make install "DESTDIR=${INSTALL_DIR}"
 	check_error $? "Error installing binutils."
 	
@@ -513,9 +502,5 @@
 	
 	change_title "GCC: install (${PLATFORM})"
-	if $REAL_INSTALL ; then
-		PATH="${PATH}:${PREFIX}/bin" make install-gcc
-	else
-		PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-gcc "DESTDIR=${INSTALL_DIR}"
-	fi
+	PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-gcc "DESTDIR=${INSTALL_DIR}"
 	check_error $? "Error installing GCC."
 	
@@ -531,5 +516,5 @@
 			"--target=${TARGET}" \
 			"--prefix=${PREFIX}" "--program-prefix=${TARGET}-" \
-			--enable-werror=no
+			--enable-werror=no --without-guile
 		check_error $? "Error configuring GDB."
 		
@@ -539,12 +524,21 @@
 		
 		change_title "GDB: make (${PLATFORM})"
-		if $REAL_INSTALL ; then
-			PATH="${PATH}:${PREFIX}/bin" make install
-		else
-			PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install "DESTDIR=${INSTALL_DIR}"
-		fi
+		PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install "DESTDIR=${INSTALL_DIR}"
 		check_error $? "Error installing GDB."
 	fi
 	
+	# Symlink clang and lld to the install path.
+	CLANG=`which clang 2> /dev/null || echo "/usr/bin/clang"`
+	LLD=`which ld.lld 2> /dev/null || echo "/usr/bin/ld.lld"`
+	
+	ln -s $CLANG "${INSTALL_DIR}/${PREFIX}/bin/${TARGET}-clang"
+	ln -s $LLD "${INSTALL_DIR}/${PREFIX}/bin/${TARGET}-ld.lld"
+	
+	if $REAL_INSTALL ; then
+		echo ">>> Moving to the destination directory."
+		cleanup_dir "${PREFIX}"
+		echo mv "${INSTALL_DIR}/${PREFIX}" "${PREFIX}"
+		mv "${INSTALL_DIR}/${PREFIX}" "${PREFIX}"
+	fi
 	
 	cd "${BASEDIR}"
Index: tools/xcw/bin/helenos-pkg-config
===================================================================
--- tools/xcw/bin/helenos-pkg-config	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ tools/xcw/bin/helenos-pkg-config	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -47,4 +47,10 @@
     $SRC_ROOT/uspace/lib/softrend/libsoftrend.a"
 
+libhound_cflags="-I$SRC_ROOT/uspace/lib/hound/include"
+libhound_libs="$SRC_ROOT/uspace/lib/hound/libhound.a"
+
+libpcm_cflags="-I$SRC_ROOT/uspace/lib/pcm/include"
+libpcm_libs="$SRC_ROOT/uspace/lib/pcm/libpcm.a"
+
 action=none
 pkg=
@@ -60,4 +66,6 @@
 	    (libdraw) ;;
 	    (libmath) ;;
+	    (libhound) ;;
+	    (libpcm) ;;
 	    (*) echo "Unknown package $1" >&2; exit 1;;
 	    esac
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,4 +48,5 @@
 	app/fontviewer \
 	app/getterm \
+	app/gunzip \
 	app/init \
 	app/inet \
@@ -80,4 +81,5 @@
 	app/nic \
 	app/ping \
+	app/pkg \
 	app/sysinfo \
 	app/sysinst \
@@ -133,4 +135,7 @@
 	srv/hid/remcons \
 	srv/hw/char/s3c24xx_uart \
+	srv/hw/irc/apic \
+	srv/hw/irc/i8259 \
+	srv/hw/irc/obio \
 	srv/hid/rfb \
 	drv/audio/hdaudio \
@@ -141,13 +146,7 @@
 	drv/block/ata_bd \
 	drv/block/ddisk \
-	drv/char/i8042 \
-	drv/char/pl050 \
-	drv/char/ps2mouse \
-	drv/char/atkbd \
-	drv/char/xtkbd \
-	drv/test/test1 \
-	drv/test/test2 \
-	drv/test/test3 \
-	drv/fb/kfb \
+	drv/bus/adb/cuda_adb \
+	drv/bus/isa \
+	drv/bus/pci/pciintel \
 	drv/bus/usb/ehci \
 	drv/bus/usb/ohci \
@@ -160,4 +159,16 @@
 	drv/bus/usb/vhc \
 	drv/bus/usb/xhci \
+	drv/char/i8042 \
+	drv/char/ns8250 \
+	drv/char/pl050 \
+	drv/char/ps2mouse \
+	drv/char/atkbd \
+	drv/char/xtkbd \
+	drv/test/test1 \
+	drv/test/test2 \
+	drv/test/test3 \
+	drv/fb/amdm37x_dispc \
+	drv/fb/kfb \
+	drv/intctl/icp-ic \
 	drv/nic/ne2k \
 	drv/nic/e1k \
@@ -165,56 +176,16 @@
 	drv/nic/rtl8169 \
 	drv/nic/ar9271 \
-	drv/platform/icp
-
-## Platform-specific hardware support
-#
-
-ifeq ($(UARCH), $(filter $(UARCH),amd64 ia32 ia64))
-	DIRS += \
-		drv/platform/pc \
-		drv/bus/pci/pciintel \
-		drv/bus/isa \
-		drv/char/ns8250 \
-		drv/time/cmos-rtc \
-		srv/hw/irc/apic \
-		srv/hw/irc/i8259
-endif
-
-ifeq ($(UARCH), $(filter $(UARCH),mips32 mips32eb))
-ifeq ($(MACHINE),msim)
-	DIRS += \
-		drv/platform/msim
-else
-	DIRS += \
-		drv/platform/malta \
-		drv/bus/pci/pciintel \
-		drv/bus/isa
-endif
-endif
-
-ifeq ($(UARCH),ppc32)
-	DIRS += \
-		drv/platform/mac \
-		drv/bus/pci/pciintel \
-		srv/hw/bus/cuda_adb
-endif
-
+	drv/platform/amdm37x \
+	drv/platform/icp \
+	drv/platform/mac \
+	drv/platform/malta \
+	drv/platform/msim \
+	drv/platform/pc \
+	drv/time/cmos-rtc
+
+## sun4u driver won't compile on 32-bit targets
 ifeq ($(UARCH),sparc64)
 	DIRS += \
-		srv/hw/irc/obio
-ifeq ($(MACHINE),generic)
-	DIRS += \
-		drv/platform/sun4u \
-		drv/bus/pci/pciintel \
-		drv/bus/isa \
-		drv/char/ns8250
-endif
-endif
-
-ifeq ($(UARCH),arm32)
-	DIRS += \
-		drv/platform/amdm37x \
-		drv/fb/amdm37x_dispc \
-		srv/hw/irc/icp-ic
+		drv/platform/sun4u
 endif
 
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -160,6 +160,13 @@
 LIBNETTL_PREFIX = $(LIB_PREFIX)/nettl
 
-AFLAGS = --fatal-warnings
+AFLAGS =
 LFLAGS = --fatal-warnings
+
+# FIXME: This condition is a workaround for issues #692 and #693.
+ifneq ($(KARCH),ia64)
+ifneq ($(KARCH),mips32)
+	AFLAGS += --fatal-warnings
+endif
+endif
 
 ifeq ($(STATIC_NEEDED),y)
@@ -203,16 +210,11 @@
 endif
 
-ifeq ($(CONFIG_OPTIMIZE_FOR_SIZE),y)
-	OPTIMIZATION = s
-else
-	OPTIMIZATION = 3
-endif
-
 # PCUT-based unit tests
 ifneq ($(TEST_SOURCES),)
 	TEST_OUTPUT = $(TEST_BINARY)
+	TEST_DISASM = $(TEST_BINARY).disasm
 	TEST_CFLAGS = -I$(LIB_PREFIX)/pcut/include -D__helenos__
 	TEST_OUTPUT_LIBS = $(LIB_PREFIX)/pcut/libpcut.a
-	EXTRA_CLEAN += $(TEST_OUTPUT) $(TEST_OUTPUT).map
+	EXTRA_CLEAN += $(TEST_OUTPUT) $(TEST_OUTPUT).map $(TEST_DISASM)
 ifneq ($(LIBRARY),)
 	TEST_OUTPUT_LIBS += $(OUTPUT)
@@ -226,5 +228,5 @@
 	-[ -f $(DEPEND) ] && cp -a $(DEPEND) $(DEPEND_PREV)
 
-all-test: $(TEST_OUTPUT)
+all-test: $(TEST_OUTPUT) $(TEST_DISASM)
 
 clean:
@@ -233,85 +235,74 @@
 	find . -name '*.lo' -follow -exec rm \{\} \;
 
-GCC_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
-	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
-	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-clobbered -Wno-unused-parameter -Wmissing-prototypes \
+COMMON_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
+	-ffreestanding -fno-builtin -nostdlib -nostdinc -fexec-charset=UTF-8 \
+	-finput-charset=UTF-8 -D__$(ENDIANESS)__
+
+GCC_CFLAGS = -ffunction-sections -Wall -Wextra -Wno-clobbered \
+	-Wno-unused-parameter -Wmissing-prototypes -std=gnu99 \
+	-Werror-implicit-function-declaration \
+	-Wwrite-strings -pipe
+
+# -Wno-missing-prototypes is there because it warns about main().
+# This should be fixed elsewhere.
+CLANG_CFLAGS = -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -Wno-typedef-redefinition \
+	-Wno-missing-prototypes -Wno-unused-command-line-argument \
 	-std=gnu99 -Werror-implicit-function-declaration -Wwrite-strings \
-	-pipe -ggdb -D__$(ENDIANESS)__
-
-ICC_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
-	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
-	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-clobbered -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Wwrite-strings \
-	-pipe -g -D__$(ENDIANESS)__
-
-# clang does not support following options but I am not sure whether
-# something won't break because of that:
-# -fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) -finput-charset=UTF-8
-CLANG_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
-	-ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
-	-std=gnu99 -Werror-implicit-function-declaration -Wwrite-strings \
-	-integrated-as -pipe -g -target $(CLANG_TARGET) -D__$(ENDIANESS)__
+	-pipe -fno-stack-protector -fno-PIC
+
+ifeq ($(CONFIG_DEBUG),y)
+	COMMON_CFLAGS += -Werror
+endif
+
+ifeq ($(CONFIG_LINE_DEBUG),y)
+	GCC_CFLAGS += -ggdb
+	CLANG_CFLAGS += -g
+endif
+
+# Prepare for POSIX before including platform specific stuff
+ifeq ($(POSIX_COMPAT),y)
+	CFLAGS += -I$(LIBPOSIX_PREFIX)/include/posix -I$(LIBPOSIX_PREFIX)/include/
+	BASE_LIBS = $(LIBPOSIX_PREFIX)/libposixaslibc.a $(LIBPOSIX_PREFIX)/libc4posix.a $(LIBSOFTINT_PREFIX)/libsoftint.a
+endif
+
+## Setup platform configuration
+#
+
+-include $(LIBC_PREFIX)/arch/$(UARCH)/Makefile.common
+
+## Compilation options
+#
+
+JOBFILE = $(LIBC_PREFIX)/../../../tools/jobfile.py
+
+ifeq ($(COMPILER),gcc_cross)
+	CFLAGS += $(COMMON_CFLAGS) $(GCC_CFLAGS)
+	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
+endif
+
+ifeq ($(COMPILER),gcc_helenos)
+	CFLAGS += $(COMMON_CFLAGS) $(GCC_CFLAGS)
+	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
+endif
+
+ifeq ($(COMPILER),gcc_native)
+	CFLAGS += $(COMMON_CFLAGS) $(GCC_CFLAGS)
+	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
+endif
+
+ifeq ($(COMPILER),clang)
+	CFLAGS += $(COMMON_CFLAGS) $(CLANG_CFLAGS)
+	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
+endif
 
 LIB_CFLAGS = $(CFLAGS) -fPIC
 LIB_LFLAGS = $(LFLAGS) -shared -soname $(LSONAME) --whole-archive
 
-ifeq ($(CONFIG_DEBUG),y)
-	GCC_CFLAGS += -Werror
-	ICC_CFLAGS += -Werror
-endif
-
-ifeq ($(CONFIG_LINE_DEBUG),y)
-	GCC_CFLAGS += -ggdb
-	ICC_CFLAGS += -g
-	CLANG_CFLAGS += -g
-endif
-
-# Prepare for POSIX before including platform specific stuff
-ifeq ($(POSIX_COMPAT),y)
-	CFLAGS = -I$(LIBPOSIX_PREFIX)/include/posix -I$(LIBPOSIX_PREFIX)/include/
-	BASE_LIBS = $(LIBPOSIX_PREFIX)/libposixaslibc.a $(LIBPOSIX_PREFIX)/libc4posix.a $(LIBSOFTINT_PREFIX)/libsoftint.a
-endif
-
-## Setup platform configuration
-#
-
--include $(LIBC_PREFIX)/arch/$(UARCH)/Makefile.common
-
-## Compilation options
-#
-
-JOBFILE = $(LIBC_PREFIX)/../../../tools/jobfile.py
-
-ifeq ($(COMPILER),gcc_cross)
-	CFLAGS += $(GCC_CFLAGS)
-	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
-endif
-
-ifeq ($(COMPILER),gcc_helenos)
-	CFLAGS += $(GCC_CFLAGS)
-	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
-endif
-
-ifeq ($(COMPILER),gcc_native)
-	CFLAGS += $(GCC_CFLAGS)
-	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
-endif
-
-ifeq ($(COMPILER),icc)
-	CFLAGS += $(ICC_CFLAGS)
-	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
-endif
-
-ifeq ($(COMPILER),clang)
-	CFLAGS += $(CLANG_CFLAGS)
-	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
-endif
-
 ifneq ($(MAKECMDGOALS),clean)
 -include $(DEPEND)
 endif
+
+AS_CFLAGS := $(addprefix -Xassembler ,$(AFLAGS))
+LD_CFLAGS := $(addprefix -Xlinker ,$(LFLAGS))
 
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
@@ -320,5 +311,5 @@
 
 ifneq ($(BINARY),)
-%.disasm: $(BINARY)
+$(BINARY).disasm: $(BINARY)
 ifeq ($(CONFIG_LINE_DEBUG),y)
 	$(OBJDUMP) -d -S $< > $@
@@ -335,5 +326,5 @@
 
 ifneq ($(SLIBRARY),)
-%.disasm: $(LOUTPUT)
+$(LOUTPUT).disasm: $(LOUTPUT)
 ifeq ($(CONFIG_LINE_DEBUG),y)
 	$(OBJDUMP) -d -S $< > $@
@@ -368,8 +359,14 @@
 	$(STRIP) $(TEST_OUTPUT)
 endif
+$(TEST_BINARY).disasm: $(TEST_BINARY)
+ifeq ($(CONFIG_LINE_DEBUG),y)
+	$(OBJDUMP) -d -S $< > $@
+else
+	$(OBJDUMP) -d $< > $@
+endif
 endif
 
 %.o: %.S $(DEPEND)
-	$(GCC) $(DEFS) $(GCC_CFLAGS) $(EXTRA_CFLAGS) -D__ASM__ -c $< -o $@
+	$(CC) $(DEFS) $(CFLAGS) $(EXTRA_CFLAGS) $(AS_CFLAGS) -D__ASM__ -c $< -o $@
 ifeq ($(PRECHECK),y)
 	$(JOBFILE) $(JOB) $< $@ as asm/preproc $(DEFS) $(CFLAGS) $(EXTRA_CFLAGS) -D__ASM__
@@ -377,5 +374,5 @@
 
 %.o: %.s $(DEPEND)
-	$(AS) $(AFLAGS) -o $@ $<
+	$(CC) $(DEFS) $(CFLAGS) $(EXTRA_CFLAGS) $(AS_CFLAGS) -D__ASM__ -c $< -o $@
 ifeq ($(PRECHECK),y)
 	$(JOBFILE) $(JOB) $< $@ as asm
@@ -395,5 +392,5 @@
 
 %.lo: %.S $(DEPEND)
-	$(CC) $(DEFS) $(LIB_CFLAGS) $(EXTRA_CFLAGS) -D__ASM__ -c $< -o $@
+	$(CC) $(DEFS) $(LIB_CFLAGS) $(EXTRA_CFLAGS) $(AS_CFLAGS) -D__ASM__ -c $< -o $@
 ifeq ($(PRECHECK),y)
 	$(JOBFILE) $(JOB) $< $@ as asm/preproc $(DEFS) $(LIB_CFLAGS) $(EXTRA_CFLAGS) -D__ASM__
@@ -401,5 +398,5 @@
 
 %.lo: %.s $(DEPEND)
-	$(AS) $(AFLAGS) -o $@ $<
+	$(CC) $(DEFS) $(LIB_CFLAGS) $(EXTRA_CFLAGS) $(AS_CFLAGS) -D__ASM__ -c $< -o $@
 ifeq ($(PRECHECK),y)
 	$(JOBFILE) $(JOB) $< $@ as asm
Index: uspace/app/barber/Makefile
===================================================================
--- uspace/app/barber/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/barber/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,7 +44,11 @@
 MATH = y
 
+IMG = image
+IMGS = $(IMG)s
+
 SOURCES = \
 	barber.c \
-	images.s
+	$(IMGS).s \
+	$(IMGS)_desc.c
 
 IMAGES = \
@@ -80,9 +84,18 @@
 	gfx/frame30.tga.gz
 
-PRE_DEPEND = images.s images.h
-EXTRA_CLEAN = images.s images.h
+PRE_DEPEND = $(IMGS).s $(IMGS).h $(IMGS)_desc.c
+EXTRA_CLEAN = $(IMGS).s $(IMGS).h $(IMGS)_desc.c $(IMGS).zip
 
 include $(USPACE_PREFIX)/Makefile.common
 
-images.s images.h: $(IMAGES)
-	$(ROOT_PATH)/tools/mkarray.py images COMPOSITOR_IMAGES "$(AS_PROLOG)" $^
+$(IMGS).s: $(IMGS).zip
+	unzip -p $< $@ > $@
+
+$(IMGS).h: $(IMGS).zip
+	unzip -p $< $@ > $@
+
+$(IMGS)_desc.c: $(IMGS).zip
+	unzip -p $< $@ > $@
+
+$(IMGS).zip: $(IMAGES)
+	$(ROOT_PATH)/tools/mkarray.py $(IMGS) $(IMG) "$(AS_PROLOG)" .data $^
